#lang racket/base
(require racket/cmdline)

(define-values (name RUNS)
  (command-line
   #:args (name runs)
   (values
    name
    (string->number runs))))

(define mod (format "OL1V3R/OL1V3R-~a/main.rkt" name))

(dynamic-require mod (void))
(define ns (current-namespace))

(printf "== OL1V3R ~a ~a ==\n" name 1)
(for ([i (in-range RUNS)])
  (parameterize ([current-namespace (make-base-namespace)])
    (namespace-attach-module-declaration ns mod)
    (parameterize ([current-command-line-arguments
                    (vector "--seed" "2"
                            "--step" "1000000"
                            "--try-real-models"
                            "--elim-eqs" "--vns"
                            (format "OL1V3R/OL1V3R-~a/test/smt-comp/QF_FP/griggio/fmcad12/gaussian.c.175.smt2"
                                    name))])
      (time (dynamic-require mod #f)))))
