#lang racket/base
(require racket/cmdline
         db)

(define-values (name RUNS)
  (command-line
   #:args (name runs)
   (values
    name
    (string->number runs))))

(define db-import-activity-from-file
  (dynamic-require (format "alog/alog-~a/rkt/database.rkt" name)
                   'db-import-activity-from-file))

(define dbapp (format "alog/alog-~a/rkt/dbapp.rkt" name))

(define open-activity-log (dynamic-require dbapp 'open-activity-log))
(define set-current-database (dynamic-require dbapp 'set-current-database))

(define (with-fresh-database thunk)
  (let ((db (open-activity-log 'memory)))
    (set-current-database db)
    (dynamic-wind
      (lambda () (void))
      (lambda () (thunk db))
      (lambda () (disconnect db)))))

(printf "== alog ~a ~a ==\n" name 1)
(for ([i (in-range RUNS)])
  (time
   (for ([file '("CraddleMoutain.fit"
                 "TrainerRoad.fit"
                 "GuilfordHills.fit"
                 "TwoRocks.fit")])
     (with-fresh-database
       (lambda (db)
         (db-import-activity-from-file
          (build-path "alog-input" file)
          db))))))

