#lang racket/base
(require db/private/pre
         db/private/sqlite3/main)

(define S 1000)
(define T 100)

(define db (sqlite3-connect #:database 'memory))

(query-exec db
            (string-append "CREATE TABLE identity "
                           "(key SMALLINT,"
                           " valud SMALLINT,"
                           " UNIQUE (key))"))

(define ins-stmt
  (virtual-statement "INSERT into identity VALUES ($1, $2)"))

(define sel-stmt
  (virtual-statement "SELECT key FROM identity WHERE key=$1"))

(time
 (call-with-transaction
  db
  (lambda ()
    (for ([i (in-range S)])
      (query-exec db ins-stmt i i))
    (for ([j (in-range T)])
      (for ([i (in-range S)])
        (query-value db sel-stmt i))))))

