;; Iterations for slow things:
(define Q (string->number (car (command-line-arguments))))

;; Number of times to run each benchmark:
(define I (string->number (cadr (command-line-arguments))))

(define would-be-M (* Q 10))

;; The depth used for non-tail recursion, typically:
(define M Q)
(define DEEP-REPEAT (/ would-be-M M))

;; If using 10 times more memory is ok:
;(define M would-be-M)
;(define DEEP-REPEAT 1)

;; Intermediate count:
(define L (* would-be-M 10))

;; Number of iteraitons used for a loop, typically
(define N (* L 10))

(define-syntax times
  (syntax-rules ()
    [(_ e)
     (let loop ([v #f] [i I])
       (if (zero? i)
           v
           (let ([v (time e)])
             (flush-output-port)
             (loop v (sub1 i)))))]))

(define-syntax repeat-for-deep
  (syntax-rules ()
    [(_ e)
     (let loop ([v #f] [k DEEP-REPEAT])
       (if (zero? k)
           v
           (loop e (sub1 k))))]))

(print-extended-identifiers #t)

(define (show v)
  (if (symbol? v)
      (printf "== ~a ~a ~a ==" v impl Q)
      (write v))
  (newline))

;; Not inlined:
(define (f x) x)
