#lang racket/base
(require racket/cmdline)

(define-values (name N RUNS)
  (command-line
   #:args (name n runs)
   (values
    name
    (string->number n)
    (string->number runs))))

(module s racket/base
  (require racket/contract/base)
  (provide (contract-out [f (-> integer? integer?)])
           unchecked-f)
  (define (f x) x)
  (define (unchecked-f x) x)
  ;; Disbale inlining:
  (set! f f)
  (set! unchecked-f unchecked-f))

(require (submod "." s))

(printf "== unchecked ~a ~a ==\n" name N)
(collect-garbage)
(for ([i (in-range RUNS)])
  (time
   (for ([x (in-range N)])
     (unchecked-f x)))
  (flush-output))

(printf "== checked ~a ~a ==\n" name N)
(collect-garbage)
(for ([i (in-range RUNS)])
  (time
   (for ([x (in-range N)])
     (f x))
   (flush-output)))
