#lang racket/base
(require racket/class
         scribble/core
         scribble/render
         scribble/text-render
         "table.rkt")

(define (table-section title table)
  (part #f
        null
        (list title)
        plain
        null
        (list table)
        null))

(define tables
  (list (table-section
         "Ctak"
         (ctak-table))

        (table-section
         "Triple"
         (triple-table))

        (table-section
         "Traditional Scheme Benchmarks"
         (scheme-table))

        (table-section
         "Continuation Attachments"
         (attach-table))

        (table-section
         "Continuation Marks"
         (mark-table))

        (table-section
         "Contracts"
         (ctc-table))

        (table-section
         "Applications"
         (app-table))

        (table-section
         "Optimizations: Effect on Continuation Marks"
         (opt-mark-table))
        
        (table-section
         "Optimizations: Effect on Contracts"
         (opt-ctc-table))

        (table-section
         "Optimizations: Effect on Applications"
         (opt-app-table))))

(render
 (list (part #f
             null
             '("Tables")
             plain
             null
             null
             tables))
 (list "results.txt")
 #:render-mixin render-mixin)

(printf "Ouput to results.txt\n")
