{-# LANGUAGE FlexibleInstances #-}

module Triple where

import System.Environment
import System.CPUTime

import CCExc

import Control.Monad
import Control.Applicative
import Control.Monad.Identity
import Control.Monad (MonadPlus(..), liftM2, msum)

type Triple = (Integer,Integer,Integer)
type Ans    = [Triple]

do_fail :: CC (P2 Ans Ans) Identity a
do_fail = shift0P p2L (\k -> return [])

do_flip :: CC (P2 Ans Ans) Identity Bool
do_flip = shift0P p2R (\k ->
                                 do ts <- (k True)
                                    fs <- (k False)
                                    return (ts ++ fs))

choice :: Integer -> CC (P2 Ans Ans) Identity Integer
choice n =
  if (n < 1)
  then do_fail
  else do side <- do_flip
          if side
          then (choice (n - 1))
          else return n

triple :: Integer -> Integer -> CC (P2 Ans Ans) Identity Triple
triple n s =
  do i <- choice n
     j <- choice (i-1)
     k <- choice (j-1)
     if (s == i+j+k)
     then return (i, j, k)
     else do_fail

to_list :: CC (P2 Ans Ans) Identity Ans -> CC (P2 Ans Ans) Identity Ans 
to_list prog = pushPrompt p2L prog

collect :: CC (P2 Ans Ans) Identity Ans -> CC (P2 Ans Ans) Identity Ans 
collect prog = pushPrompt p2R prog

handled_triples_list :: Integer -> Integer -> CC (P2 Ans Ans) Identity Ans
handled_triples_list n s = collect (to_list  (do t <- (triple n s)
                                                 return [t]))

go_list :: Integer -> Ans
go_list n = runIdentity $ runCC (handled_triples_list n n)

go n = print (length (go_list n))

timed_go n = do start <- getCPUTime
                r <- go n
                end <- getCPUTime
                putStr "cpu msec: "
                print (quot (end - start) 1000000000)

timed_go_many n runs =
  if (runs == 1)
  then timed_go n
  else do timed_go n
          timed_go_many n (runs-1)

main = do args <- getArgs
          let n = (read $ head args :: Integer)
          let runs = (read $ head (tail args) :: Integer)
          timed_go_many n runs
