effect Flip : unit -> bool
effect Fail : unit -> 'a

let rec choice n =
  if (n < 1)
    then perform (Fail ())
    else if (perform (Flip ()))
      then n
      else choice (n - 1)

let triple n s =
  let i = choice n in
  let j = choice (i - 1) in
  let k = choice (j - 1) in
  if (i + j + k == s)
    then (i, j ,k)
    else perform (Fail ())

(* Swapping the order of handlers silently fails! *)
let handledTriple n s =
  try
  try
    let r = triple n s in [r]
  with
  | effect (Fail ()) k -> []
  with
  | effect (Flip ()) k ->
      let xs = continue (Obj.clone_continuation k) true in
      let ys = continue k false in
      List.append xs ys

let n = int_of_string Sys.argv.(1)
let runs = int_of_string Sys.argv.(2)

let run_once () =
  let start_time = Sys.time () in
  let result = List.length (handledTriple n n) in
  let end_time = Sys.time () in
  Printf.printf "%f secs cpu time\n" (end_time -. start_time) ;
  Printf.printf "%d" result ;
  print_newline ()

let rec run_n runs =
  if (runs == 1)
    then run_once ()
    else (run_once () ; run_n (runs-1))

let _ = run_n runs
