(define-syntax thunk
  (syntax-rules ()
    [(_ e) (lambda () e)]))

(define fail-prompt (new-prompt))
(define flip-prompt (new-prompt))

(define (do-fail) (shift0 fail-prompt k '()))
(define (do-flip) (shift0 flip-prompt k (append (k #t) (k #f))))

(define (choice n)
  (if (< n 1)
      (do-fail)
      (if (do-flip)
          (choice (- n 1))
          n)))

(define (triple n s)
  (let* ([i (choice n)]
         [j (choice (- i 1))]
         [k (choice (- j 1))])
    (if (= s (+ i j k))
        (list i j k)
        (do-fail))))


(define (to-list prog)
  (push-prompt fail-prompt (prog)))

(define (collect prog)
  (push-prompt flip-prompt (prog)))

(define (handled-triples-list n s)
  (collect (thunk
            (to-list (thunk
                      (list (triple n s)))))))

(define N (string->number (car argv)))
(define runs (string->number (cadr argv)))

(let loop ([j runs] [r #f])
  (if (zero? j)
      r
      (loop
       (- j 1)
       (time (begin
               (write (length (handled-triples-list N N)))
               (newline))))))
